Package org.springframework.context

# Interface Lifecycle

All Known Subinterfaces:
  `ConfigurableApplicationContext`, `LifecycleProcessor`, `SmartLifecycle`

All Known Implementing Classes:
  `AbstractApplicationContext`, `AbstractRefreshableApplicationContext`, `AbstractRefreshableConfigApplicationContext`, `AbstractXmlApplicationContext`, `AnnotationConfigApplicationContext`, `ClassPathXmlApplicationContext`, `DefaultLifecycleProcessor`, `ExecutorConfigurationSupport`, `FileSystemXmlApplicationContext`, `GenericApplicationContext`, `GenericGroovyApplicationContext`, `GenericXmlApplicationContext`, `ScheduledExecutorFactoryBean`, `SimpleAsyncTaskScheduler`, `StaticApplicationContext`, `ThreadPoolExecutorFactoryBean`, `ThreadPoolTaskExecutor`, `ThreadPoolTaskScheduler`

public interface Lifecycle
A common interface defining methods for start/stop lifecycle control. The typical use case for this is to control asynchronous processing. NOTE: This interface does not imply specific auto-startup semantics. Consider implementing `SmartLifecycle` for that purpose.

Can be implemented by both components (typically a Spring bean defined in a Spring context) and containers (typically a Spring `ApplicationContext` itself). Containers will propagate start/stop signals to all components that apply within each container, for example, for a stop/restart scenario at runtime.

Can be used for direct invocations or for management operations via JMX. In the latter case, the `MBeanExporter` will typically be defined with an `InterfaceBasedMBeanInfoAssembler`, restricting the visibility of activity-controlled components to the Lifecycle interface.

Note that the present `Lifecycle` interface is only supported on top-level singleton beans. On any other component, the `Lifecycle` interface will remain undetected and hence ignored. Also, note that the extended `SmartLifecycle` interface provides sophisticated integration with the application context's startup and shutdown phases.

Since:
  2.0
Author:
  Juergen Hoeller
See Also:
  - `SmartLifecycle`
  - `ConfigurableApplicationContext`
  - `org.springframework.jms.listener.AbstractMessageListenerContainer`
  - `org.springframework.scheduling.quartz.SchedulerFactoryBean`

## Method Summary

Modifier and Type
Method
Description
`boolean`
`isRunning()`
Check whether this component is currently running.
`void`
`start()`
Start this component.
`void`
`stop()`
Stop this component, typically in a synchronous fashion, such that the component is fully stopped upon return of this method.

## Method Details

### start

void start()
Start this component.

Should not throw an exception if the component is already running.

In the case of a container, this will propagate the start signal to all components that apply.

See Also:
  - `SmartLifecycle.isAutoStartup()`

### stop

void stop()
Stop this component, typically in a synchronous fashion, such that the component is fully stopped upon return of this method. Consider implementing `SmartLifecycle` and its `stop(Runnable)` variant when asynchronous stop behavior is necessary.

Note that this stop notification is not guaranteed to come before destruction: On regular shutdown, `Lifecycle` beans will first receive a stop notification before the general destruction callbacks are being propagated; however, on hot refresh during a context's lifetime or on aborted refresh attempts, a given bean's destroy method will be called without any consideration of stop signals upfront.

Should not throw an exception if the component is not running (not started yet).

In the case of a container, this will propagate the stop signal to all components that apply.

See Also:
  - `SmartLifecycle.stop(Runnable)`
  - `DisposableBean.destroy()`

### isRunning

boolean isRunning()
Check whether this component is currently running.

In the case of a container, this will return `true` only if all components that apply are currently running.

Returns:
  whether the component is currently running